package com.ghostsq.commander.adapters;

import android.net.Uri;

import java.io.File;
import java.util.Date;

import static com.ghostsq.commander.adapters.CommanderAdapter.MODE_SORTING;
import static com.ghostsq.commander.adapters.CommanderAdapter.SORT_DATE;
import static com.ghostsq.commander.adapters.CommanderAdapter.SORT_SIZE;

public class FileItem extends CommanderAdapter.Item implements FSEngines.IFileItem {
    public boolean needAttrs = false;
    public FileItem( File f ) {
        this( f, 0, false );
    }
    public FileItem( File f, int mode, boolean deferred ) {
        origin = f;
        name = f.getName();
        if( deferred ) {
            dir  = f.isDirectory();
            int sm = mode & MODE_SORTING;
            if( sm == SORT_SIZE )
                size = f.length();
            else if( sm == SORT_DATE ) {
                long msFileDate = f.lastModified();
                if( msFileDate != 0 )
                    date = new Date( msFileDate );
            }
            this.needAttrs = true;
            return;
        }
        dir  = f.isDirectory();
        if( !dir )
            size = f.length();
        long msFileDate = f.lastModified();
        if( msFileDate != 0 )
            date = new Date( msFileDate );
    }
    @Override
    public File f() {
        return origin != null ? (File)origin : null;
    }
    @Override
    public Uri getUri() {
        if( !(origin instanceof File) )
            return null;
        Uri.Builder ub = new Uri.Builder();
        return ub.scheme( "file" ).path( ( (File)origin).getAbsolutePath() ).build();
    }
}
